package protocol

var (
	_ marshalConfigOption   = WithTagName("hcl")
	_ unmarshalConfigOption = WithTagName("hcl")
)

type WithTagName string

func (o WithTagName) applyToMarshalConfig(cfg *marshalConfig) {
	cfg.TagName = string(o)
}

func (o WithTagName) applyToUnmarshalConfig(cfg *unmarshalConfig) {
	cfg.TagName = string(o)
}

func defaultConfig() protocolConfig {
	return protocolConfig{
		TagName: "hcl",
	}
}

type protocolConfig struct {
	TagName string
}
